package glzt.common.unit;



import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.params.ClientPNames;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import android.util.Log;

public class HttpService{
	private static final String TAG = "CustomerHttpClient";
	private DefaultHttpClient hostHttpClient;
	private DefaultHttpClient inetHttpClient;
	private static final String CHARSET = HTTP.UTF_8;
	// origin
	private final int defaultTimeout = 60000; // default 1 min
	private final int resolveTimeout = 60000; // default 1 min

	// ivate final int retryTimeout = 2000;
	public static HttpService instance;

	private boolean isAbort;

	private HttpService() {
		setAbort(false);
	}

	public static synchronized HttpService getInstance() {
		if (instance == null) {
			instance = new HttpService();
		}
		return instance;
	}

	public HttpResponse get2(String url, NameValuePair... params)
			throws ClientProtocolException, IOException {

		StringBuffer sb = new StringBuffer();
		sb.append(url).append("?");
		for (NameValuePair p : params) {
			sb.append(p.toString());
			sb.append("&");
		}
		sb.setLength(sb.length() - 1);
		String request = sb.toString();

		HttpGet httpGet = new HttpGet(request);
		DefaultHttpClient client = getHostHttpClient();

		HttpResponse response = client.execute(httpGet); // 发起GET请求

		return response;

	}

	public String resolveDns(String url) throws ClientProtocolException,
			IOException {

		HttpGet httpGet = new HttpGet(url);
		DefaultHttpClient client = getInetHttpClient();
		HttpResponse response = client.execute(httpGet);

		Header hd = response.getFirstHeader("Location");
		if (hd != null)

			return hd.getValue();
		else
			return "";
	}

	public String resolveDns2(String url) throws ClientProtocolException,
			IOException {

		HttpGet httpGet = new HttpGet(url);
		DefaultHttpClient client = getHostHttpClient();
		HttpResponse response = client.execute(httpGet); // 发起GET请求

		if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
			return "";
		} else {
			String s = EntityUtils.toString(response.getEntity(), CHARSET);
			return s;
		}

	}

	public String getWithAuth(int rankType, String url, NameValuePair... params) {
		try {
			HttpGet httpGet = null;
			List<NameValuePair> paramList = new ArrayList<NameValuePair>(); // 请求参数
			for (NameValuePair p : params) {
				paramList.add(p);
			}
			String param = URLEncodedUtils.format(paramList, "UTF-8");
			// 对参数编?
			// UrlEncodedFormEntity entity = new
			// UrlEncodedFormEntity(paramList,CHARSET);
			if (rankType == -1) {
				httpGet = new HttpGet(url + "?" + param);// 增对有参数情?
			} else {
				httpGet = new HttpGet(url);// 增对无参数情?
			}

			httpGet.addHeader("Authorization",
					"hAng AGU32J26tEkVkfQzqpLI2O6soI9aDbnuU2UsUTaKFUD0-XQItgLphY5huR22Teqp1bg=");

			DefaultHttpClient client = getHostHttpClient();

			HttpResponse response = client.execute(httpGet); // 发起GET请求

			if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
				return "";
			} else {
				String s = EntityUtils.toString(response.getEntity(), CHARSET);
				// String s = EntityUtils.toString(response.getEntity());
				return s;
			}
		} catch (UnsupportedEncodingException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (ClientProtocolException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (IOException e) {
			return null;
		} catch (Exception e) {
			return null;
		}
	}

	// NameValuePair... params
	public String getCheckBlnSameWifiEth(String qurl) {
		// HttpURLConnection连接URL
		// 1创建?个URL对象
		URL url = null;
		try {
			url = new URL(qurl);
		} catch (MalformedURLException e1) {
			// TODO Auto-generated catch block
			
			e1.printStackTrace();
			return null;
		}
		// 2利用HttpURLConnection对象从网络中获取网页数据
		HttpURLConnection conn = null; // 连接对象
		InputStream is = null;
		String resultData = "";

		try {
			conn = (HttpURLConnection) url.openConnection(); //使用URL打开?个链?,其实建立?个TCP连接
			conn.setDoInput(true); //允许输入流，即允许下?  
			conn.setDoOutput(true); //允许输出流，即允许上?  
			conn.setUseCaches(false); //不使用缓?  
			conn.setRequestMethod("GET"); //使用get请求  
			conn.setConnectTimeout(3 * 1000);// 3设置连接超时

			// 5得到网络返回的输入流
			is = conn.getInputStream();
			
			// 4对响应码进行判断

			if (conn.getResponseCode() == 200) { // 从Internet获取网页,发?请?,将网页以流的形式读回?
				
				BufferedReader bufferReader = new BufferedReader(
						new InputStreamReader(is));
				String inputLine = "";
				while ((inputLine = bufferReader.readLine()) != null) {
					resultData += inputLine + "\n";

				}
				conn.disconnect();
			} else {
				throw new RuntimeException("请求url失败");
				// send message to hanlder timeout
			}

		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (conn != null) {
				conn.disconnect();
			}
		}

		return resultData;
	}

	public String get(String url, NameValuePair... params) {
		try {

			HttpGet httpGet = null;
			List<NameValuePair> paramList = new ArrayList<NameValuePair>(); // 请求参数
			Log.i("paramList", "from get aramList.size() ==" + paramList.size());
			for (NameValuePair p : params) {
				paramList.add(p);
			}

			String request = "";
			if (paramList.size() > 0)
				request = url + "?"
						+ URLEncodedUtils.format(paramList, "UTF-8");
			else
				request = url;

			httpGet = new HttpGet(request);

			DefaultHttpClient client = getHostHttpClient();

			HttpResponse response = client.execute(httpGet); // 发起GET请求 BUG，如果一?
			// 正在登录，然后去添加设备，就会出现BUG

			if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
				return "";
			} else {
				String s = EntityUtils.toString(response.getEntity(), CHARSET);
				// String s = EntityUtils.toString(response.getEntity());
				return s;
			}
		} catch (UnsupportedEncodingException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (ClientProtocolException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (IOException e) {
			return null;
		} catch (Exception e) {
			Log.i("CustomerHttpClient", "access failed");

			e.printStackTrace();

			return null;
		}

	}

	// origin
	// public String get(String url, NameValuePair... params) {
	// try {
	//
	// HttpGet httpGet = null;
	// List<NameValuePair> paramList = new ArrayList<NameValuePair>(); // 请求参数
	// Log.i("paramList", "from get aramList.size() ==" + paramList.size());
	// for (NameValuePair p : params) {
	// paramList.add(p);
	// }
	//
	// String request = "";
	// if (paramList.size() > 0)
	// request = url + "?"
	// + URLEncodedUtils.format(paramList, "UTF-8");
	// else
	// request = url;
	//
	// httpGet = new HttpGet(request);
	//
	//
	// DefaultHttpClient client = getHostHttpClient();
	// HttpResponse response = client.execute(httpGet); // 发起GET请求
	//
	// if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
	// return "";
	// } else {
	// String s = EntityUtils.toString(response.getEntity(), CHARSET);
	// // String s = EntityUtils.toString(response.getEntity());
	// return s;
	// }
	// } catch (UnsupportedEncodingException e) {
	// Log.w(TAG, e.getMessage());
	// return null;
	// } catch (ClientProtocolException e) {
	// Log.w(TAG, e.getMessage());
	// return null;
	// } catch (IOException e) {
	// return null;
	// } catch (Exception e) {
	// return null;
	// }
	//
	// }

	public String get3(String url, NameValuePair... params) {
		try {
			List<NameValuePair> paramList = new ArrayList<NameValuePair>(); // 请求参数
			for (NameValuePair p : params) {
				paramList.add(p);
			}

			String request = "";
			if (paramList.size() > 0)
				request = url + "?"
						+ URLEncodedUtils.format(paramList, "UTF-8");
			else
				request = url;
			// 对参数编?
			// UrlEncodedFormEntity entity = new
			// UrlEncodedFormEntity(paramList,CHARSET);
			HttpGet httpGet = new HttpGet(request);

			DefaultHttpClient client = getHostHttpClient();

			HttpResponse response = client.execute(httpGet); // 发起GET请求

			if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
				return "";
			} else {
				String s = EntityUtils.toString(response.getEntity(), CHARSET);
				return s;
			}
		} catch (UnsupportedEncodingException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (ClientProtocolException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (IOException e) {
			return null;
		} catch (Exception e) {
			return null;
		}
	}

	

	public String post(String url, NameValuePair... params) {
		try {
			// 编码参数
			List<NameValuePair> paramList = new ArrayList<NameValuePair>(); // 请求参数
			for (NameValuePair p : params) {
				paramList.add(p);
			}
			UrlEncodedFormEntity entity = new UrlEncodedFormEntity(paramList,
					CHARSET);
			// 创建POST请求
			HttpPost request = new HttpPost(url);
			request.setEntity(entity);
			// 发?请?
			DefaultHttpClient client = getHostHttpClient();

			HttpResponse response = client.execute(request);

			if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
				StatusLine s = response.getStatusLine();
				Log.d(TAG, s.toString());
				return null;
			} else {
				String s = EntityUtils.toString(response.getEntity(), "utf-8");
				return s;
			}
		} catch (UnsupportedEncodingException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (ClientProtocolException e) {
			Log.w(TAG, e.getMessage());
			return null;
		} catch (IOException e) {
			// throw new RuntimeException("连接失败", e);
			Log.i("CustomerHttpClient", "access failed");
			e.printStackTrace();
			return null;
		}

	}

	public String postWithTimeout(String url, int timeout,
			NameValuePair... params) {
		hostHttpClient.getParams().setParameter(
				CoreConnectionPNames.SO_TIMEOUT, timeout);
		return post(url, params);
	}

	public synchronized DefaultHttpClient getInetHttpClient() {
		if (null == inetHttpClient) {
			inetHttpClient = new DefaultHttpClient();
		}
		inetHttpClient.getParams().setParameter(
				CoreConnectionPNames.CONNECTION_TIMEOUT, resolveTimeout);
		inetHttpClient.getParams().setParameter(
				CoreConnectionPNames.SO_TIMEOUT, resolveTimeout);
		inetHttpClient.getParams().setParameter(ClientPNames.HANDLE_REDIRECTS,
				false);
		return inetHttpClient;
	}

	public synchronized DefaultHttpClient getHostHttpClient() {
		if (null == hostHttpClient) {
			hostHttpClient = new DefaultHttpClient();
			DefaultHttpClient client = new DefaultHttpClient();
			ClientConnectionManager mgr = client.getConnectionManager();
			HttpParams params = client.getParams();

			HttpProtocolParams.setContentCharset(params, CHARSET);
			hostHttpClient = new DefaultHttpClient(
					new ThreadSafeClientConnManager(params,
							mgr.getSchemeRegistry()), params);
			// hostHttpClient = new DefaultHttpClient(params);
		}
		hostHttpClient.getParams().setParameter(
				CoreConnectionPNames.CONNECTION_TIMEOUT, defaultTimeout);
		hostHttpClient.getParams().setParameter(
				CoreConnectionPNames.SO_TIMEOUT, defaultTimeout);

		return hostHttpClient;
	}

	public boolean isAbort() {
		return isAbort;
	}

	public void setAbort(boolean isAbort) {
		this.isAbort = isAbort;
	}
}
