package glzt.ui.video;

//import gl.inet.base.AlogrithmUntil;
//import gl.inet.base.BaseService;
//import gl.inet.base.GuiUtil;
//import gl.inet.common.Const;
//import gl.inet.common.HttpService;
//import gl.inet.common.RouteDevice;
//import gl.inet.common.RouteService;
//import gl.inet.common.ServiceMsg;

import glzt.common.unit.HttpService;

import java.util.ArrayList;
import java.util.HashMap;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class VideoService{
	
	private HashMap<String,VideoDevice> videosMap;
	private ArrayList<VideoDevice> videoList;
	private int firstSupportVideoDevIndex;
	public int currentIndex;
	public String fps;
	public String resolution;
	
	public int resolutionIndex;
	public int fpsIndex;
	
	//private RouteService rs = RouteService.getInstance();
	private static VideoService instance;
	
	private  VideoService(){
		videosMap = new HashMap<String,VideoDevice>();
		videoList = new ArrayList<VideoDevice>();
		reset();
	}
	
	public static synchronized VideoService getInstance(){
		if(instance==null)
			instance = new VideoService();
		return instance;
	}

	public void reset(){
		videosMap.clear();
		videoList.clear();
		currentIndex=-1;
		resolutionIndex=-1;
		fpsIndex=-1;
		resolution="";
		fps="";
		firstSupportVideoDevIndex=-1;
	}
	
	public String getDescription(){
		VideoDevice vd = getCurrentVideo();
		if(vd==null){
          return "Const.INET_VIDEO_NODEVICE_AVAILABLE2";
		}else{
          return vd.getModel();  
		}
	}
	 
	public ArrayList<HashMap<String, Object>> getDevicesItems3(){
		ArrayList<HashMap<String, Object>> list = new 
				ArrayList<HashMap<String, Object>>();
		for(int i=0;i<videoList.size();i++){
			HashMap<String, Object> h = new HashMap<String, Object>();
			h.put("title", videoList.get(i).getName());
			h.put("info", videoList.get(i).getDescription());
			list.add(h);
		}
		
		return list;
	}
	
	public String[] getDevicesItems(){
		String[] a = new String[videoList.size()];
		for(int i=0;i<a.length;i++){
			a[i]=videoList.get(i).getName();
		}
		
		return a;
	}
	
	public String getDevicesItems2(){
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<videoList.size();i++){
			sb.append(videoList.get(i).getName()).append(",");
		}
		if(sb.length()>0)
			sb.setLength(sb.length()-1);
		return sb.toString();
	}
	
	public  String[] getFpsnItems2(){
		String[] fps = {"5","10","15","20","25","30"};
		return fps;
	}
	
//	public  ArrayList<HashMap<String, Object>> getFpsnItems(){
//		String[] fps = {"5","10","15","20","25","30"};
//		ArrayList<HashMap<String, Object>> list3 = new 
//				ArrayList<HashMap<String, Object>>();
//		for(int i=0;i<fps.length;i++){
//			HashMap<String, Object> h = new HashMap<String, Object>();
//			h.put("title", fps[i]);
//			list3.add(h);
//		}
//		
//		fpsIndex=AlogrithmUntil.findStringArray(fps,this.fps,true);
//		return list3;
//	}
	
//	public ArrayList<HashMap<String, Object>> getResolutionItems3(String name){
//		ArrayList<HashMap<String, Object>> list = new 
//				ArrayList<HashMap<String, Object>>();
//		VideoDevice video = videosMap.get(name);
//		if(video==null)
//			return list;
//		String[] a = video.resolutions();
//		for(int i=0;i<a.length;i++){
//			HashMap<String, Object> h = new HashMap<String, Object>();
//			h.put("title", a[i]);
//			list.add(h);
//		}
//		
//		resolutionIndex=AlogrithmUntil.findStringArray(a,resolution,true);
//		
//		return list;
//	}
	
	public String[] getResolutionItems(String name){
		VideoDevice video = videosMap.get(name);
		if(video==null)
			return new String[0];
		
		return video.resolutions();
	}
	
	public String getResolutionItems2(String name){
		VideoDevice video = videosMap.get(name);
		if(video==null)
			return "";
		
		return video.resolutions2();
	}
	
	public void getVideosAsync(final String URL){
		new Thread(new Runnable(){
			@Override
			public void run() {
				// TODO Auto-generated method stub
				int videos = getVideos(URL);
				boolean success=false;
				String message="";				
				boolean check = checkVideo();
				if(videos<0 ){
					//message = Const.INET_VIDEO_NODEVICE_AVAILABLE;
				}				
				else  if(!check){
		        	//message = Const.INET_VIDEO_NODEVICE_AVAILABLE;
				}else{
					success=true;
				}
				
//				sendMessageToControllers(
//						ServiceMsg.ON_MSG_REQUEST_VIDEOS_INFO,
//						success,0,message);
			}
			
		}).start();
	}
	
	public int getVideos(String URL){
		
		currentIndex=-1;
		String urlRequest = URL+"/video_cgi?action=get";
		
		String resp = glzt.common.unit.HttpService.getInstance().get(urlRequest);
		if(resp==null || resp.isEmpty()){
//			setOperationResultDescription(
//					Const.INET_SYS_COMMUNICATION_NO_RESPONSE);
			return -1;
	    }
		
	    try {
			JSONObject root = new JSONObject(resp);
			JSONArray devices = root.getJSONArray("devices");
			if(devices.length()==0){
				return 0;
			}
			
			JSONObject config = root.getJSONObject("config");
			//String device = config.getString("device");
			setFps(config.getString("fps"));
			resolution = config.getString("resolution");
			videoList.clear();
			videosMap.clear();
			for(int i=0;i<devices.length();i++){
				JSONObject video = devices.getJSONObject(i);
				VideoDevice videoDev= new VideoDevice(video);
				if(videoDev.supportMJPEG()||videoDev.supportYUV()){
					if(firstSupportVideoDevIndex==-1)
						firstSupportVideoDevIndex=i;
				}
				videoList.add(videoDev);
				videosMap.put(videoDev.getName(), videoDev);
			}
			} catch (JSONException e) {
				e.printStackTrace();
				return -2;			
			}
	    
	    return 1;
	}
	
	public VideoDevice getVideoDevice(int index){
		if(index!=-1){
			return videoList.get(index);
		}else
			return null;
	}
	
	public String toString(){
		VideoDevice video = getCurrentVideo();
		if(video!=null){
			return resolution+"/"+getFps()+"fps"+"@"+video.getName();
		}
		return "";
	}
	
	public void setVideoParamAsync(final String name,final 
			String resolution,final String fps,final String url){
		new Thread(new Runnable(){
			@Override
			public void run() {
//				sendMessageToControllers(
//						ServiceMsg.ON_MSG_SETTING_VIDEO_INFO,
//						true,0,"");
				boolean success = setVideoParam(name,resolution,fps,url);
//				sendMessageToControllers(
//						ServiceMsg.ON_MSG_SETTED_VIDEO_INFO,
//						success,0,"");
			}
		}).start();
	}
	
	//url = dev.routeHostCGI() == http://192.168.8.1/cgi-bin
	//url == Const.INET_HTTP+getLocalIp()+Const.INET_CGI
	public void restart(String URL){
		VideoService vs = VideoService.getInstance();
		VideoDevice vd = vs.getCurrentVideo(); 
		vs.setVideoParam(vd.getName(),
				vs.resolution, vs.fps,URL);
	}
	
	// url = dev.routeHostCGI() == http://192.168.8.1/cgi-bin
	public boolean setVideoParam(String name,String resolution,String fps,String url){
		

	    
	    boolean setResult=false;
        String urlRequest= url+"/video_cgi";
        NameValuePair param1 = new BasicNameValuePair("action", "set");
		NameValuePair param2 = new BasicNameValuePair("device", name);
        NameValuePair param3 = new BasicNameValuePair("resolution", resolution);
        NameValuePair param4 = new BasicNameValuePair("fps", fps);

        String resp = HttpService.getInstance().postWithTimeout(urlRequest,10000,param1, param2,param3,param4);
        if(resp==null || resp.isEmpty())
        	setResult= false;
        else{
        	try {
        		JSONObject root = new JSONObject(resp);
        		setResult = root.getBoolean("success");
        	} catch (JSONException e) {
        		// TODO Auto-generated catch block
        		setResult= false;
        	}
        }      
        if(setResult){
        	this.resolution=resolution;
    		this.setFps(fps);
        }
        
		return setResult;
	}	
	
	public void setCurrentIndex(int index){ 
		this.currentIndex=index;
	}
	
	public int getCurrentIndex(){ 
		if(currentIndex==-1)
			currentIndex=firstSupportVideoDevIndex;
		return currentIndex;
	}
	
	public boolean checkVideo(){
		return firstSupportVideoDevIndex!=-1;
	}
	
	public VideoDevice getCurrentVideo(){
		if(currentIndex==-1)
			currentIndex=firstSupportVideoDevIndex;
		if(videoList.size()==0 ||currentIndex==-1)
			return null;
		
		return videoList.get(currentIndex);
	}

	public String getFps() {
		return fps;
	}

	public void setFps(String fps) {
		this.fps = fps;
	}

	public boolean hasVideo() {
		// TODO Auto-generated method stub
		return videoList.size()>0;
	}

	public boolean checkVideoUI() {
		if(!checkVideo()){
//			GuiUtil.applyNotify(getActivity(), 
//					Const.INET_VIDEO_NODEVICE_AVAILABLE, 
//					false);
			return false;
		}
		return true;
	}
}
