package glzt.util;

import java.util.List;

import android.content.Context;  
import android.net.wifi.ScanResult;  
import android.net.wifi.WifiConfiguration;  
import android.net.wifi.WifiInfo;  
import android.net.wifi.WifiManager;  
import android.net.wifi.WifiManager.WifiLock;  
import android.util.Log;  
  
public class WifiAdmin {  
    private final static String TAG = "WifiAdmin";  
    private StringBuffer mStringBuffer = new StringBuffer();  
    private List<ScanResult> listResult;  
    private ScanResult mScanResult;  
    // WifiManager  
    private WifiManager mWifiManager;  
    // WifiInfo  
    private WifiInfo mWifiInfo;  
    // б  
    private List<WifiConfiguration> mWifiConfiguration;  
    // һWifiLock  
    WifiLock mWifiLock;  
  
    /** 
     * 췽 
     */  
    public WifiAdmin(Context context) {  
        mWifiManager = (WifiManager) context  
                .getSystemService(Context.WIFI_SERVICE);  
        mWifiInfo = mWifiManager.getConnectionInfo();  
    }  
  
    /** 
     * Wifi 
     */  
    public void openNetCard() {  
        if (!mWifiManager.isWifiEnabled()) {  
            mWifiManager.setWifiEnabled(true);  
        }  
    }  
  
    /** 
     * رWifi 
     */  
    public void closeNetCard() {  
        if (mWifiManager.isWifiEnabled()) {  
            mWifiManager.setWifiEnabled(false);  
        }  
    }  
  
    /** 
     * 鵱ǰWifi״̬ 
     */  
    public void checkNetCardState() {  
        if (mWifiManager.getWifiState() == 0) {  
            Log.i(TAG, "ڹر");  
        } else if (mWifiManager.getWifiState() == 1) {  
            Log.i(TAG, "Ѿر");  
        } else if (mWifiManager.getWifiState() == 2) {  
            Log.i(TAG, "ڴ");  
        } else if (mWifiManager.getWifiState() == 3) {  
            Log.i(TAG, "Ѿ");  
        } else {  
            Log.i(TAG, "---_---......ûлȡ״̬---_---");  
        }  
    }  
  
    /** 
     * ɨܱ 
     */  
    public void scan() {  
        mWifiManager.startScan();  
        listResult = mWifiManager.getScanResults();  
        if (listResult != null) {  
            Log.i(TAG, "ǰ磬鿴ɨ");  
        } else {  
            Log.i(TAG, "ǰû");  
        }  
    }  
  
    /** 
     * õɨ 
     */  
    public String getScanResult() {  
        // ÿεɨ֮ǰһεɨ  
        if (mStringBuffer != null) {  
            mStringBuffer = new StringBuffer();  
        }  
        // ʼɨ  
        scan();  
        listResult = mWifiManager.getScanResults();  
        if (listResult != null) {  
            for (int i = 0; i < listResult.size(); i++) {  
                mScanResult = listResult.get(i);  
                mStringBuffer = mStringBuffer.append("NO.").append(i + 1)  
                        .append(" :").append(mScanResult.SSID).append("->")  
                        .append(mScanResult.BSSID).append("->")  
                        .append(mScanResult.capabilities).append("->")  
                        .append(mScanResult.frequency).append("->")  
                        .append(mScanResult.level).append("->")  
                        .append(mScanResult.describeContents()).append("\n\n");  
            }  
        }  
        Log.i(TAG, mStringBuffer.toString());  
        return mStringBuffer.toString();  
    }  
  
    /** 
     * ָ 
     */  
    public void connect() {  
        mWifiInfo = mWifiManager.getConnectionInfo();  
          
    }  
  
    /**
     * ϴӵ
     */
    public boolean reConnect(){
    	return mWifiManager.reconnect();
    }
    
    /** 
     * Ͽǰӵ 
     */  
    public void disconnectWifi() {  
        int netId = getNetworkId();  
        mWifiManager.disableNetwork(netId);  
        mWifiManager.disconnect();  
        mWifiInfo = null;  
    }  
  
    /** 
     * 鵱ǰ״̬ 
     *  
     * @return String 
     */  
    public void checkNetWorkState() {  
        if (mWifiInfo != null) {  
            Log.i(TAG, "");  
        } else {  
            Log.i(TAG, "ѶϿ");  
        }  
    }  
  
    /** 
     * õӵID 
     */  
    public int getNetworkId() {  
        return (mWifiInfo == null) ? 0 : mWifiInfo.getNetworkId();  
    }  
  
    /** 
     * õIPַ 
     */  
    public int getIPAddress() {  
        return (mWifiInfo == null) ? 0 : mWifiInfo.getIpAddress();  
    }  
  
    // WifiLock  
    public void acquireWifiLock() {  
        mWifiLock.acquire();  
    }  
  
    // WifiLock  
    public void releaseWifiLock() {  
        // жʱ  
        if (mWifiLock.isHeld()) {  
            mWifiLock.acquire();  
        }  
    }  
  
    // һWifiLock  
    public void creatWifiLock() {  
        mWifiLock = mWifiManager.createWifiLock("Test");  
    }  
  
    // õúõ  
    public List<WifiConfiguration> getConfiguration() {  
        return mWifiConfiguration;  
    }  
  
    // ָúõ  
    public void connectConfiguration(int index) {  
        // úõ  
        if (index >= mWifiConfiguration.size()) {  
            return;  
        }  
        // úõָID  
        mWifiManager.enableNetwork(mWifiConfiguration.get(index).networkId,  
                true);  
    }  
  
    // õMACַ  
    public String getMacAddress() {  
        return (mWifiInfo == null) ? "NULL" : mWifiInfo.getMacAddress();  
    }  
  
    // õBSSID  
    public String getBSSID() {  
        return (mWifiInfo == null) ? "NULL" : mWifiInfo.getBSSID();  
    }  
  
    // õWifiInfoϢ  
    public String getWifiInfo() {  
        return (mWifiInfo == null) ? "NULL" : mWifiInfo.toString();  
    }  
  
    // һ粢  
    public int addNetwork(WifiConfiguration wcg) {
    	
        //int wcgID = mWifiManager.addNetwork(mWifiConfiguration.get(3));
    	int wcgID = mWifiManager.addNetwork(wcg);
        mWifiManager.enableNetwork(wcgID, true);  
        return wcgID;  
    }  
}  