/*
 * Copyright (C) 2011 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package glzt.wifi.control;

import glzt.util.ConstantData;

import glzt.util.ProfileList;
import glzt.util.jni.JniEngine;
import glzt.wifi.control.BasicCtrlSurfaceView.PointerState;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.util.AttributeSet;
import android.util.Log;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.util.ArrayList;
import java.util.Date;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.Rect;
import android.opengl.GLES20;
import android.opengl.GLSurfaceView;
import android.opengl.GLUtils;
import android.opengl.Matrix;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.VelocityTracker;
import android.view.SurfaceHolder.Callback;

class BasicGLSurfaceView extends GLSurfaceView {
	// 

	public static class PointerState {
		private final ArrayList<Float> mXs = new ArrayList<Float>();
		private final ArrayList<Float> mYs = new ArrayList<Float>();
		private boolean mCurDown;
		private int zoneFlag; // ־Ƿ
		private int mCurX;
		private int mCurY;
		private float mCurPressure;
		private float mCurSize;
		private int mCurWidth;
		private VelocityTracker mVelocity;
	}

	private int mMaxVelocityX = 0, mMaxVelocityY = 0;
	protected static final int MAX_VELOCITY_X = 2000;
	protected static final int MAX_VELOCITY_Y = 2000;
	private boolean mCurDown;
	private int mCurNumPointers;
	private int mMaxNumPointers;
	private final ArrayList<PointerState> mPointers = new ArrayList<PointerState>();

	private Thread threadDraw;
	private SurfaceHolder sfh;
	private Canvas canvas;
	private Paint paint;
	private boolean drawFlag;

	// Ļߴı
	// private int ScreenWidth, ScreenHeight;
	// Ļ = /խ
	private float screenScale = 1.0f;
	private float screenStretchX = 1.0f, screenStretchY = 1.0f;

	public static int screenWidth, screenHeight;

	public static ProfileList currentPL = new ProfileList();

	protected static final int OFFSET_DIR_RIGHT = 20;
	protected static final int OFFSET_DIR_LEFT = 20;
	protected static final int OFFSET_DIR_BOTTOM = 20;
	protected static final int OFFSET_ACC_RIGHT = 45;
	protected static final int OFFSET_ACC_LEFT = 50;
	protected static final int OFFSET_ACC_BOTTOM = 10;

	// ǣ
	protected static final int ACC_ZONE = 1;
	protected static final int DIR_ZONE = 2;
	protected static final int MAX_TOUCHPOINTS = 2;// 

	// 㶨
	private Point directionCenter = new Point(); // ĵ
	private int directionRadius; // 뾶ڴ⣩

	private Point accAreaCenter = new Point(); // ĵ
	private Point accLeftTop = new Point(); // Ͻ
	private Point accRightBottom = new Point();// ½
	private Point zeroSpeedPoint = new Point(); // ֹ꣨ˣ
	private Point leverCenter = new Point(); // ʵʱµĵ

	// ת
	private float rotateDegree = 0;
	private float maxRotateDegree = 60.0f; // ĬǶΪ60ȣֵӦÿԵ

	private static float accRatio = 0.6f; // ǰֺͺȫг̵ıʾֹʱеλ
	public static boolean isInRealTimeCfg = false;
	private static boolean isAccAreaModified = false;

	public static String button_str;

	// ͵ϢУʾλΪ΢Ϊ1000΢롫2000΢룬ֵֹ/תʱΪ1500΢
	private static int iEPAPositive[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iEPANegative[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iMidPoint[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iDR[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static float iEXP[] = new float[ConstantData.MAX_CHANNEL_NUM];

	private static boolean bChnRev[] = new boolean[ConstantData.MAX_CHANNEL_NUM];
	private int iAccPulseWidth, iDirPulseWidth;
	protected static final int DEFAULT_MID_POINT = 1500;// Ĭеֵ
	protected static final int DEFAULT_SCALE = 500; // Ĭ巶ΧֵҪ

	// surfaceview淢Ϣwifiģ飺
	public static Socket socketServer = null;
	private BufferedWriter writer;

	// λͼԴ
	private Bitmap bmpBackground;
	private Bitmap bmpDirection;
	private Bitmap bmpBar;
	private Bitmap bmpLever;
	private Bitmap bmpConnOK;
	private Bitmap bmpConnBroken;
	private Matrix matrixDir, matrixBar, matrixLever;
	private float bmpDirStrech = 1.0f, bmpBarStrechX = 1.0f,
			bmpBarStrechY = 1.0f, bmpLeverStrech = 1.0f;
	private Rect dirtyACC;
	private Rect dirtyDIR;
	private Rect dirtyWifi;
	int accLeft = 0;
	int accTop = 0;
	int leverLeft = 0;
	int leverTop = 0;
	int dirLeft = 0;
	int dirTop = 0;
	int wifiLeft = 0;
	int wifiTop = 0;

	// ʱжϣΪfalseһmsgΪtrueֻΪfalse
	private static boolean isMsgSend = false;

	private Thread threadTimer;
	private boolean isTimerEnable = false;

	private static final int SEND_TIMER = 200; // ֻfail safeʱʱλΪms
	private static int msgData[] = { DEFAULT_MID_POINT, DEFAULT_MID_POINT,
			DEFAULT_MID_POINT, DEFAULT_MID_POINT };
	private static int lastMsgData[] = new int[ConstantData.MAX_CHANNEL_NUM]; // ϴη͵
	private static long lastSendTime = 0;
	private static long sendTime = 0;

	private static boolean isSendABS = false;
	protected static final int MSG_SEND_BY_TIMER = 4001;
	protected static final int MSG_RT_TRM_UP = 4010;
	protected static final int MSG_RT_TRM_DOWN = 4011;
	protected static final int MSG_RT_TRM_LEFT = 4012;
	protected static final int MSG_RT_TRM_RIGHT = 4013;
	protected static final int MSG_RT_DR_UP = 4020;
	protected static final int MSG_RT_DR_DOWN = 4021;
	protected static final int MSG_RT_DR_LEFT = 4022;
	protected static final int MSG_RT_DR_RIGHT = 4023;

	/**
	 * surfaceviewĺṩ̣߳UI̺߳Ⱦ̡߳Ӧע⣺ 1>
	 * SurfaceViewSurfaceHolder.CallbackķӦUI߳
	 * һ˵Ӧó̡߳Ⱦ߳ҪʵĸֱӦͬ 2>
	 * surfaceܱ٣ֻSurfaceHolder.Callback.surfaceCreated()
	 * SurfaceHolder.Callback.surfaceDestroyed()֮ЧҪȷȾ̷߳ʵǺϷЧsurface
	 * 
	 * @param context
	 * @param attrs
	 *            ͨSurfaceHolderӿڷSurface.getHolder()Եõӿڡ
	 * 
	 *            SurfaceHolder ʾһsurfaceĳӿڣʹԿsurfaceĴС͸ʽ
	 *            Լsurfaceϱ༭أͼsuraceĸı䡣ӿͨͨSurfaceViewʵ֡
	 * 
	 *            SurfaceHolder.Callback
	 *            ûʵִ˽ӿڽsurface仯ϢһSurfaceView ʱ
	 *            ֻSurfaceHolder.Callback
	 *            .surfaceCreated()SurfaceHolder.Callback
	 *            .surfaceDestroyed()֮Ч.
	 *            CallbackķSurfaceHolder.addCallback.
	 */
	public BasicGLSurfaceView(Context context, AttributeSet attrs) {
		super(context);
		Log.v("Mike144", "BasicGLSurfaceView");
		this.setKeepScreenOn(true);
		sfh = this.getHolder();
		sfh.addCallback(this);
		paint = new Paint();// 
		paint.setAntiAlias(true);// ÿž
		setFocusable(true);
		setFocusableInTouchMode(true);

		// wifi code

		PointerState ps = new PointerState();// 㴥
		ps.mVelocity = VelocityTracker.obtain();// VelocityTracker ٶȸ
		mPointers.add(ps);// ٶȸ
		// wifi coded end

		/**
		 * Inform the default EGLContextFactory and default EGLConfigChooser
		 * which GL Context client version to pick. Use this method to create an
		 * OpenGL ES 2.0-compatible context.
		 * 
		 * Note: Activities which require OpenGL ES 2.0 should indicate this by
		 * setting @lt;uses-feature android:glEsVersion="0x00020000" /> in the
		 * activity's AndroidManifest.xml file. If this method is called, it
		 * must be called before setRenderer(Renderer) is called. This method
		 * only affects the behavior of the default EGLContexFactory and the
		 * default EGLConfigChooser. If setEGLContextFactory(EGLContextFactory)
		 * has been called, then the supplied EGLContextFactory is responsible
		 * for creating an OpenGL ES 2.0-compatible context. If
		 * setEGLConfigChooser(EGLConfigChooser) has been called, then the
		 * supplied EGLConfigChooser is responsible for choosing an OpenGL ES
		 * 2.0-compatible config.
		 */
		setEGLContextClientVersion(2);

		/**
		 * GLSurfaceViewĳʼsetRenderer
		 * setRendererעһGLSurfaceView.Renderer滭OpenGLʵʵĻ滭
		 * GLSurfaceView.Renderer. RendererִʵʵOpenGLȾ.
		 */
		setRenderer(new BasicGLRenderer(context));
	}

	/**
	 * ActivityеonTouchEventMotionEvent event Override
	 * onTouchEvent...Ϊʽ onTouchEventMotionEvent event{ return
	 * super.onTouchEvent(event); }
	 * Ĭϵsuper.onTouchEvent(...)falseֻһ㱻
	 * returnֵĳtrueʱϵͳڵõtrueָ
	 * ôļûбʧЧ㴥ؾ͵ʵˡֵΪtrue֮
	 * ڷڼӸһ£Կeventڶ㴥ص
	 * ȡeventڴӦı䡣ϵõĻ¼ĸֵͨswitchɸѡͿԵõĻܵĴ
	 */
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		synchronized (mPointers) {
			Point touchPoint = new Point();
			int NP = mPointers.size(); // NP ΪǰаĴ
			int action = event.getAction();
			if (action == MotionEvent.ACTION_DOWN) {
				// 㰴µ¼
				for (int p = 0; p < NP; p++) {
					final PointerState ps = mPointers.get(p);// ǰ
					ps.mXs.clear();// X
					ps.mYs.clear();// Y
					ps.mVelocity = VelocityTracker.obtain();// ٶȸ
					ps.mCurDown = false;// ?
				}
				// if(mPointers.size()!=0){
				mPointers.get(0).mCurDown = true;
				// }
				mMaxNumPointers = 0;
			}

			if ((action & MotionEvent.ACTION_MASK) == MotionEvent.ACTION_POINTER_DOWN) {
				// 㰴ʱĳ㰴¼
				final int index = (action & MotionEvent.ACTION_POINTER_INDEX_MASK) >>> MotionEvent.ACTION_POINTER_INDEX_SHIFT;
				final int id = event.getPointerId(index);
				while ((NP <= id) && (id <= MAX_TOUCHPOINTS)) {
					// ֻMAX_TOUCHPOINTS㡣
					PointerState ps = new PointerState();
					ps.mVelocity = VelocityTracker.obtain();
					mPointers.add(ps);
					NP++;
				}
				final PointerState ps = mPointers.get(id);
				ps.mVelocity = VelocityTracker.obtain();
				ps.mCurDown = true;
			}

			final int NI = event.getPointerCount();// õǰevent¼ Ӵ

			mCurDown = action != MotionEvent.ACTION_UP
					&& action != MotionEvent.ACTION_CANCEL;
			mCurNumPointers = mCurDown ? NI : 0;
			if (mMaxNumPointers < mCurNumPointers) {
				mMaxNumPointers = mCurNumPointers;
			}

			/**
			 * event.getHistorySize();ǹȥĶļΪһʵһϵжϳɵģȺ˳ɡ
			 * Ⱥ˳ ͨgetHistorySizeʷĴСֵԷصǰ¼õ˶λõĿ
			 * ȻͨʹһϵgetHistorical*ݸλÿһʷ¼ʱ䡢ѹСλ
			 * 
			 * ˶¼һģʽȴÿһʷ¼浱ǰMotionEventֵ
			 */
			for (int i = 0; i < NI; i++) {
				final int index = event.getPointerId(i); // index!!! ԭΪ id
				final PointerState ps = mPointers.get(index);
				ps.mVelocity.addMovement(event);// ǰ¼ٶȸ
				ps.mVelocity.computeCurrentVelocity(1);// 1px λΪصٶ
				final int N = event.getHistorySize();
				for (int j = 0; j < N; j++) {
					ps.mXs.add(event.getHistoricalX(i, j));
					ps.mYs.add(event.getHistoricalY(i, j));
				}
				ps.mXs.add(event.getX(i));
				ps.mYs.add(event.getY(i));
				ps.mCurX = (int) event.getX(i);
				ps.mCurY = (int) event.getY(i);

				ps.mCurPressure = event.getPressure(i);
				ps.mCurSize = event.getSize(i);
				ps.mCurWidth = (int) (ps.mCurSize * (getWidth() / 3));
			}

			// 㴥̧ʱ
			if ((action & MotionEvent.ACTION_MASK) == MotionEvent.ACTION_POINTER_UP) {
				final int index = (action & MotionEvent.ACTION_POINTER_INDEX_MASK) >> MotionEvent.ACTION_POINTER_INDEX_SHIFT;
				final int id = event.getPointerId(index);
				final PointerState ps = mPointers.get(id);
				ps.mXs.add(Float.NaN);// 0
				ps.mYs.add(Float.NaN);// 0
				ps.mCurDown = false;
			}

			if (action == MotionEvent.ACTION_UP) {
				for (int i = 0; i < NI; i++) {
					final int id = event.getPointerId(i);
					final PointerState ps = mPointers.get(id);
					if (ps.mCurDown)
						ps.mCurDown = false;
				}
			}
			/*
			 * synchronized(lock){ try { lock.wait(TIME); } catch
			 * (InterruptedException e) { // TODO Auto-generated catch block
			 * e.printStackTrace(); } }
			 */
			// ȡ.................

			// ʼµϢleverCenterrotateDegree
			// ٶʱٸ£ΪԾleverCenterrotateDegree
			NP = mPointers.size();
			if (NP >= MAX_TOUCHPOINTS) {
				Log.d("onTouchEvent",
						"too much point founded: " + String.valueOf(NP));
			}

			for (int p = 0; p < NP; p++) {
				final PointerState ps = mPointers.get(p);

				/**
				 * a = (x>y)?m:n 3Ԫ 3Ԫĵһboolean,ڶֵȺߵҪһ¡ 
				 * x>yõĽǵһֵ һbooleanֵֵΪ true  aֵΪm,aֵΪn;
				 */
				int velocity = ps.mVelocity == null ? 0 : (int) (ps.mVelocity
						.getXVelocity() * 1000);
				mMaxVelocityX = mMaxVelocityX > velocity ? velocity
						: mMaxVelocityX;

				velocity = ps.mVelocity == null ? 0 : (int) (ps.mVelocity
						.getYVelocity() * 1000);
				mMaxVelocityY = mMaxVelocityY > velocity ? velocity
						: mMaxVelocityY;

				// ٶ̫죬ԹӦ
				if ((mMaxVelocityX > MAX_VELOCITY_X)
						|| (mMaxVelocityY > MAX_VELOCITY_Y)){
					continue;
				}

				touchPoint.x = (int) ps.mCurX;
				touchPoint.y = (int) ps.mCurY;
				if (mCurDown && ps.mCurDown) {
					// 㰴
					if (isInAccZone(touchPoint)) {
						// 
						if (DIR_ZONE == ps.zoneFlag) {
							// ӷʱҪ̹㣬˴Ϊд˴
							rotateDegree = 0;
							iDirPulseWidth = processDIR(touchPoint, touchPoint);

							if (ConstantData.INVALID_VALUE == iDirPulseWidth) {
								Log.e("processDIR", "get invalid pulse width");
							} else {
								ps.zoneFlag = 0;
								// ݵwifi
								if (null != socketServer) {
									synchronized (msgData) {
										msgData[ConstantData.CHANNEL_DIR] = iDirPulseWidth;
									} 
									try {
										Log.e("Mike334",
												"sending message  in SurfaceView");
										// ʹ˴ηҪǷ,Ƿabsϴεȷ
										sendMsg(socketServer, msgData,
												isSendABS);
										isMsgSend = true;
									} catch (Exception e) {
										Log.e("Mike334",
												"send message failed. in SurfaceView");
									}
								}
								// ݽ
							}
						} else {
							ps.zoneFlag = ACC_ZONE;

							leverCenter.x = accAreaCenter.x;
							;
							leverCenter.y = touchPoint.y;

							// zeroSpeedPoint.x = accAreaCenter.x;

							// modified by mike 2012 06 14
							// zeroSpeedPoint.y = screenHeight -
							// bmpBar.getHeight()*3/10;
							// zeroSpeedPoint.y = accAreaCenter.y;
							// end of modified 2012 06 14

							iAccPulseWidth = processACC(leverCenter,
									zeroSpeedPoint);
							if (ConstantData.INVALID_VALUE == iAccPulseWidth) {
								Log.e("processACC", "get invalid pulse width");
							} else {
								// ݵwifi
								if (null != socketServer) {
									synchronized (msgData) {
										msgData[ConstantData.CHANNEL_ACC] = iAccPulseWidth;
									}
									try {
										sendMsg(socketServer, msgData,
												isSendABS);
										isMsgSend = true;
									} catch (Exception e) {
										Log.e("Mike282",
												"send message failed. in SurfaceView");
									}
								}
								// ݽ
							}
						}
					} else if (isInDirectionZone(touchPoint)) // Ƿ
					{
						if (ACC_ZONE == ps.zoneFlag) {
							// ʱҪŹ㣬ҷ˴Ϊд˴
							leverCenter.x = zeroSpeedPoint.x;

							// modified by mike 2012 06 14
							// move zero point to center,
							// ظֵʱֱָģyϵ1/2
							// leverCenter.y = screenHeight -
							// bmpBar.getHeight()*3/10;
							leverCenter.y = zeroSpeedPoint.y;
							// end of modified

							ps.zoneFlag = 0;
							iAccPulseWidth = processACC(touchPoint, touchPoint);// עҪEPAõУ
							if (ConstantData.INVALID_VALUE == iAccPulseWidth) {
								Log.e("processACC", "get invalid pulse width");
							} else {
								// ݵwifi
								if (null != socketServer) {
									synchronized (msgData) {
										msgData[ConstantData.CHANNEL_ACC] = iAccPulseWidth;
									}
									try {
										sendMsg(socketServer, msgData,
												isSendABS);
										isMsgSend = true;
									} catch (Exception e) {
										Log.e("Mike423",
												"send ACC message failed. in SurfaceView");
									}
								}
								// ݽ
							}
						} else {
							ps.zoneFlag = DIR_ZONE;

							// ұߴг̣תΪ
							iDirPulseWidth = processDIR(touchPoint,
									directionCenter);

							if (ConstantData.INVALID_VALUE == iDirPulseWidth) {
								Log.e("processDIR", "get invalid pulse width");
							} else {
								// ݵwifi
								if (null != socketServer) {
									synchronized (msgData) {
										msgData[ConstantData.CHANNEL_DIR] = iDirPulseWidth;
									}
									try {
										sendMsg(socketServer, msgData,
												isSendABS);
										isMsgSend = true;
									} catch (Exception e) {
										Log.e("Mike334",
												"send message failed. in SurfaceView");
									}
								}
								// ݽ
							}
						}
					}
				} else if (!ps.mCurDown) {
					// ָ̧뿪ĻʱĴ
					if (ACC_ZONE == ps.zoneFlag) {
						leverCenter.x = zeroSpeedPoint.x;

						leverCenter.y = zeroSpeedPoint.y;

						ps.zoneFlag = 0;
						iAccPulseWidth = processACC(touchPoint, touchPoint);
						if (ConstantData.INVALID_VALUE == iAccPulseWidth) {
							Log.e("processACC", "get invalid pulse width");
						} else {
							// ݵwifi
							if (null != socketServer) {
								synchronized (msgData) {
									msgData[ConstantData.CHANNEL_ACC] = iAccPulseWidth;
								}
								try {
									sendMsg(socketServer, msgData, isSendABS);
									isMsgSend = true;
								} catch (Exception e) {
									Log.e("Mike282",
											"send message failed. in SurfaceView");
								}
							}
							// ݽ
						}
					}

					if (DIR_ZONE == ps.zoneFlag) {
						rotateDegree = 0;
						ps.zoneFlag = 0;
						iDirPulseWidth = processDIR(touchPoint, touchPoint);
						if (ConstantData.INVALID_VALUE == iDirPulseWidth) {
							Log.e("processDIR", "get invalid pulse width");
						} else {
							// ݵwifi
							if (null != socketServer) {
								synchronized (msgData) {
									msgData[ConstantData.CHANNEL_DIR] = iDirPulseWidth;
								}
								try {
									sendMsg(socketServer, msgData, isSendABS);
									isMsgSend = true;
								} catch (Exception e) {
									Log.e("Mike334",
											"send message failed. in SurfaceView");
								}
							}
							// ݽ
						}
					}
				} // Ϊ
			} // end of for (int p=0; p<NP; p++)
		} // end of synchronized()

		return true;
	}

	/*
	 * ϢwifiԶ
	 * 
	 * @param Socket socket, the socket that can send msg out
	 * 
	 * @param String Msg, message to be send
	 */
	public void sendMsg(Socket socket, int data[], boolean isSendABSFlag)
			throws IOException {
		String Msg;
		// PWMź ʽ#0,1500,1500,1500,1500#
		// ǳ23λڶλ0ʾPWMֵÿPWMֵ4λмж
		// ABSϢ,ʽΪ:#0,1500,1500,1500,1500,xx#,xxΪ2λʾABSֵ
		String msgString = new String();
		String strABS = new String();
		// isSendABSFlag == true,ABSֵΪ0,ʾҪABSϢ;ϢвذABSϢ
		synchronized (msgData) {

			if ((0 != currentPL.iABS) && (isSendABSFlag)) {
				if (currentPL.iABS < 10) {
					strABS = "0" + String.valueOf(currentPL.iABS);
				} else {
					strABS = String.valueOf(currentPL.iABS);
				}
				msgString = "#4," + String.valueOf(data[0]) + ","
						+ String.valueOf(data[1]) + ","
						+ String.valueOf(data[2]) + ","
						+ String.valueOf(data[3]) + "," + strABS + "#";
			} else {
				msgString = "#0," + String.valueOf(data[0]) + ","
						+ String.valueOf(data[1]) + ","
						+ String.valueOf(data[2]) + ","
						+ String.valueOf(data[3]) + "#";
			}

			// շϢ:
			// 1. ϴηʱ0.1ms
			// 2. ϴη͵10us
			// ǰ:
			// 1. ¼ǰʱtick
			// 2. жǷҪ(ǰʱ,ϴηʱȽ/ǰϴݱȽ)
			// 3. 緢,ͺ,ǰʱlast,ǰݼlast
			// 4. 粻,ֱ
			boolean differFlag = false;
			for (int i = 0; i < currentPL.iChannelNum; i++) {
				if (Math.abs((msgData[i] - lastMsgData[i])) > 10) {
					differFlag = true;
					break;
				}
			}
			sendTime = System.currentTimeMillis();
			if (((sendTime - lastSendTime) > 100) || (differFlag)) {
				/**
				 * debug ӡ if((sendTime-lastSendTime)<180)
				 * Log.i("Time differ",String.valueOf(sendTime-lastSendTime));
				 */
				// Ϸ,
				if (socket.isConnected()) {
					/**
					 * debug ӡ if((sendTime-lastSendTime)<180)
					 * Log.e("sendTime differ"
					 * ,String.valueOf(sendTime-lastSendTime));
					 * if((sendTime-lastSendTime)<100){ for(int x=0;x<4;x++){
					 * if(Math.abs((msgData[x]-lastMsgData[x]))>10){
					 * Log.e("data differ"
					 * +String.valueOf(x),String.valueOf(msgData
					 * [x]-lastMsgData[x])); } } }
					 */
					Log.d("sendMsg",
							"msgString =="+msgString);
					writer = new BufferedWriter(new OutputStreamWriter(
							socket.getOutputStream()));
					writer.write(msgString); // ִʱעⲻ\n
					writer.flush();
					// ͳɹ,򽫷"ϴη"
					for (int i = 0; i < ConstantData.MAX_CHANNEL_NUM; i++) {
						lastMsgData[i] = msgData[i];
					}
					lastSendTime = sendTime;
				} else {
					Log.d("sendMsg",
							"send message failed due to socket is not connected");
				}
			}
		}
	}

	/**
	 * ݴ÷תǶ
	 * 
	 * @param touchPoint
	 * @param circleCenter
	 * @return
	 */
	private double getDegree(Point touchPoint, Point circleCenter) {
		// õXľ
		int x = touchPoint.x - circleCenter.x;
		// õYľ
		int y = circleCenter.y - touchPoint.y;

		float rad, Degree = 0;
		float pie = 3.14159265f;
		// ͨкȡǶȶӦĻ
		if (y == 0) {
			rad = pie / 2;
		} else {
			rad = (float) Math.atan(x / y);
		}

		Degree = (float) (rad * 180 / pie);

		return Degree;
	}

	private boolean isInAccZone(Point touchPoint) {
		if (isInRealTimeCfg) {
			// ʵʱ״̬ҪСһΧ
			if (!isAccAreaModified) {
				accLeftTop.x += 30;
				accRightBottom.x -= 30;
				isAccAreaModified = true;
			}
		} else {
			// ʵʱ״ָ̬ԭΧ
			if (isAccAreaModified) {
				accLeftTop.x -= 30;
				accRightBottom.x += 30;
				isAccAreaModified = false;
			}
		}
		// жǷ
		// ޸ģmodified by mike 2012 06 14 ±߽粻ʱжΪֵ߽û飩
		// ߽粻ʱΪֵ߽Ȼȥȡ
		/**
		 * if ((accLeftTop.x<=touchPoint.x)&&(accRightBottom.x>=touchPoint.x)
		 * &&(accLeftTop.y<=touchPoint.y)&&(accRightBottom.y>=touchPoint.y)){
		 * return true; }
		 */
		if ((accLeftTop.x <= touchPoint.x)
				&& (accRightBottom.x >= touchPoint.x)) {
			if ((accLeftTop.y <= touchPoint.y)
					&& (accRightBottom.y >= touchPoint.y))
				return true;
			if ((accLeftTop.y > touchPoint.y)
					&& (accLeftTop.y - 50 < touchPoint.y)) {
				// javaѧߣֱӸıʵtouchPointĳԱֵֵᴫݳȥ൱CԵ
				touchPoint.y = accLeftTop.y;
				return true;
			} else if ((accRightBottom.y < touchPoint.y)
					&& (accRightBottom.y + 50 > touchPoint.y)) {
				touchPoint.y = accRightBottom.y;
				return true;
			}
		}
		// ޸Ľ 2012 06 14 enf of modified
		return false;
	}

	private boolean isInDirectionZone(Point touchPoint) {
		// жǷڷ
		double distanceToRight = Math.sqrt(Math.pow(
				(directionCenter.x - touchPoint.x), 2)
				+ Math.pow((directionCenter.y - touchPoint.y), 2));
		if ((distanceToRight <= (directionRadius * 4 / 3))
				&& (touchPoint.y < directionCenter.y)) {
			return true;
		}
		return false;
	}

	/**
	 * ͨתĬţҲ෽̡תҲʾΪ
	 * 
	 * @return ɹtrueʧܷfalse
	 */
	private void processChnRev(int width, int height) {

		int widthDirect, heightDirect, widthBar, heightBar, widthLever, heightLever;
		widthDirect = (int) (bmpDirStrech * bmpDirection.getWidth());
		heightDirect = (int) (bmpDirStrech * bmpDirection.getHeight());
		widthBar = (int) (bmpBarStrechX * bmpBar.getWidth());
		heightBar = (int) (bmpBarStrechY * bmpBar.getHeight());
		widthLever = (int) (bmpLeverStrech * bmpLever.getWidth());
		heightLever = (int) (bmpLeverStrech * bmpLever.getHeight());

		directionRadius = widthDirect / 2;

		if ((currentPL.iControlMode == ConstantData.BASIC_TOUCH_MODE)
				|| (currentPL.iControlMode == ConstantData.BASIC_RELATIVE_TOUCH_MODE)) {
			directionCenter.x = width - widthDirect / 2 - OFFSET_DIR_RIGHT;
			directionCenter.y = height - heightDirect / 2 + OFFSET_DIR_BOTTOM;

			accAreaCenter.x = widthBar / 2 + OFFSET_ACC_LEFT;
			accAreaCenter.y = height - heightBar / 2 - OFFSET_ACC_BOTTOM;
			accLeftTop.x = 0 + OFFSET_ACC_LEFT;
			accLeftTop.y = height - heightBar - OFFSET_ACC_BOTTOM;
			accRightBottom.x = widthBar + OFFSET_ACC_LEFT;
			accRightBottom.y = height - OFFSET_ACC_BOTTOM;
			zeroSpeedPoint.x = accAreaCenter.x;
			// modified by mike 2012 06 14
			zeroSpeedPoint.y = (int) (height - heightBar * (1 - accRatio) - OFFSET_ACC_BOTTOM);
			// zeroSpeedPoint.y = accAreaCenter.y;
			// end of modified 2012 06 14
		} else if (currentPL.iControlMode == ConstantData.BASIC_TOUCH_REV_MODE) {

			// ΪBASIC_TOUCH_REV_MODEʾת: Ļ
			directionCenter.x = widthDirect / 2 + OFFSET_DIR_LEFT;
			directionCenter.y = height - heightDirect / 2 + OFFSET_DIR_BOTTOM;

			accAreaCenter.x = width - widthBar / 2 - OFFSET_ACC_RIGHT;
			accAreaCenter.y = height - heightBar / 2 - OFFSET_ACC_BOTTOM;
			accLeftTop.x = width - widthBar - OFFSET_ACC_RIGHT;
			accLeftTop.y = height - heightBar - OFFSET_ACC_BOTTOM;
			accRightBottom.x = width - OFFSET_ACC_RIGHT;
			accRightBottom.y = height - OFFSET_ACC_BOTTOM;
			zeroSpeedPoint.x = accAreaCenter.x;
			// modified by mike 2012 06 14
			zeroSpeedPoint.y = (int) (height - heightBar * (1 - accRatio) - OFFSET_ACC_BOTTOM);
			// zeroSpeedPoint.y = accAreaCenter.y;
			// end of modified 2012 06 14
		}
		leverCenter.x = zeroSpeedPoint.x;
		leverCenter.y = zeroSpeedPoint.y;

		accLeft = accAreaCenter.x - (bmpBar.getWidth() / 2);
		accTop = accAreaCenter.y - (bmpBar.getHeight() / 2);
		leverLeft = leverCenter.x - (bmpLever.getWidth() / 2) + 3;
		leverTop = leverCenter.y - (bmpLever.getHeight() / 2) + 1;
		dirLeft = directionCenter.x - (bmpDirection.getWidth() / 2);
		dirTop = directionCenter.y - (bmpDirection.getHeight() / 2);
		wifiLeft = 300;
		wifiTop = 10;
	}

	public static boolean commitConfig() {
		if (0 >= currentPL.iChannelNum) {
			Log.e("processConfig", "invalid channel num,in currentPL");
			return false;
		}

		// ֵ
		// (1500+TRM*500)+500*DR*throttle,throttleǸֵ㵽е/ֵе룩
		// 糬iEPAPositiveiEPANegativeԴֵΪշȣ
		// DEFAULT_MID_POINT+DEFAULT_SCALE*(currentPL.iTrim[i]/100)+DEFAULT_SCALE*(curentPL.iDR[i]/100)*deltaWidth
		// iMidPoint[i]+iDR[i]*deltaWidth
		for (int i = 0; i < currentPL.iChannelNum; i++) {
			iMidPoint[i] = (int) (DEFAULT_MID_POINT + DEFAULT_SCALE
					* ((float) currentPL.iTrim[i] / 100f));
			iEPAPositive[i] = (int) (DEFAULT_MID_POINT + DEFAULT_SCALE
					* ((float) currentPL.iEPAPositive[i] / 100f));
			iEPANegative[i] = (int) (DEFAULT_MID_POINT + DEFAULT_SCALE
					* ((float) currentPL.iEPANegative[i] / 100f));
			iDR[i] = (int) (DEFAULT_SCALE * ((float) currentPL.iDR[i] / 100f));

			bChnRev[i] = currentPL.bChannelReverse[i];
			iEXP[i] = currentPL.iEXPControl[i] / 100f;

			synchronized (msgData) {
				// ,
				msgData[i] = iMidPoint[i]; // (int)(DEFAULT_MID_POINT +
											// DEFAULT_SCALE*((float)currentPL.iTrim[i]/100f));
			}
		}
		if (currentPL.iChannelNum < ConstantData.MAX_CHANNEL_NUM) {
			synchronized (msgData) {
				for (int i = currentPL.iChannelNum; i < ConstantData.MAX_CHANNEL_NUM; i++) {
					msgData[i] = DEFAULT_MID_POINT;
				}
			}
		}

		return true;
	}

	/**
	 * ¼תΪ塣תʱTRIMϢ
	 * 
	 * @param touchPoint
	 *            
	 * @param gasCenter
	 *            Ϊ0
	 * @return ɹtrueʧܷfalse
	 */
	private int processACC(Point touchPoint, Point accCenter) {
		/**
		 * Աʱ
		 */
		/*
		 * Date d=new Date(); long ms;
		 */

		if (isInRealTimeCfg) {
			// ʵʱ״̬ҪСһΧ
			if (!isAccAreaModified) {
				accLeftTop.x += 30;
				accRightBottom.x -= 30;
				isAccAreaModified = true;
			}
		} else {
			// ʵʱ״ָ̬ԭΧ
			if (isAccAreaModified) {
				accLeftTop.x -= 30;
				accRightBottom.x += 30;
				isAccAreaModified = false;
			}
		}
		// 1. ½λãͼ̻߳Զػ£

		// 2. λתΪ͸wifiģ

		int pulseWidth = ConstantData.INVALID_VALUE;
		// ȼexp裺
		// 1. expλΪٷֱȣ0-1ĸtֵ
		// 2. xyתΪ0-1֮ĸ
		// 3. y=xtηٽyתΪֵ
		double t = 0.0;
		double y = 0.0;
		double x = 0.0;

		t = Math.pow(4, -1 * iEXP[ConstantData.CHANNEL_ACC]);

		if (accCenter.y <= touchPoint.y) {
			x = Math.abs((double) (accCenter.y - touchPoint.y)
					/ (double) (bmpBar.getHeight() * (1 - accRatio)));
		} else {
			x = Math.abs((double) (accCenter.y - touchPoint.y)
					/ (double) (bmpBar.getHeight() * accRatio));
		}

		if (x > 1.0) {
			x = 1.0;
			Log.d("processAcc", "x>1");
		}
		y = Math.pow(x, t);

		// ֵҪͨתãbChnRev[]һж
		if (!bChnRev[ConstantData.CHANNEL_ACC]) {
			// ֵʱDRƫ
			if (accCenter.y < touchPoint.y) {
				isSendABS = true;
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_ACC] - DEFAULT_SCALE
						* y);
			} else {
				isSendABS = false;
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_ACC] + iDR[ConstantData.CHANNEL_ACC]
						* y);
			}
		} else {
			if (accCenter.y > touchPoint.y) {
				isSendABS = true;
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_ACC] - DEFAULT_SCALE
						* y);
			} else {
				isSendABS = false;
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_ACC] + iDR[ConstantData.CHANNEL_ACC]
						* y);
			}
		}

		// end of modified 2012 06 14

		if (iEPANegative[ConstantData.CHANNEL_ACC] > pulseWidth) {
			pulseWidth = iEPANegative[ConstantData.CHANNEL_ACC];
		} else if (iEPAPositive[ConstantData.CHANNEL_ACC] < pulseWidth) {
			pulseWidth = iEPAPositive[ConstantData.CHANNEL_ACC];
		}

		/**
		 * Աʱ
		 */
		/*
		 * ms = new Date().getTime()-d.getTime();
		 * Log.e("processACC:",String.valueOf(ms)+"ms");
		 */

		return pulseWidth;
	}

	/**
	 * ¼תΪ塣תʱTRIMϢ
	 * 
	 * @param touchPoint
	 *            
	 * @param directionCenter
	 *            
	 * @return ش
	 */
	private int processDIR(Point touchPoint, Point dirCenter) {
		/**
		 * Աʱ
		 */
		/*
		 * Date d=new Date(); long ms;
		 */

		// 1. λתΪǶ, ½淽̽Ƕȣͼ̻߳Զػ£
		// 2. תǶתΪ͸wifiģ
		int pulseWidth = ConstantData.INVALID_VALUE;
		JniEngine jniEngine = new JniEngine();

		if (0 != (dirCenter.y - touchPoint.y)) {
			// double tempRad = Math.atan((double)(dirCenter.x-
			// touchPoint.x)/(double)(touchPoint.y - dirCenter.y));
			// rotateDegree = (float)(tempRad*180/3.14159265);

			rotateDegree = (float) jniEngine.getDegreeNDK(touchPoint.x,
					touchPoint.y, dirCenter.x, dirCenter.y);

			if (rotateDegree > maxRotateDegree) {
				rotateDegree = maxRotateDegree;
			} else if (rotateDegree < ((-1) * maxRotateDegree)) {
				rotateDegree = (-1) * maxRotateDegree;
			}
		} else {
			rotateDegree = 0;
		}

		// ȼexp裺
		// 1. expλΪٷֱȣ0-1ĸtֵ
		// 2. xyתΪ0-1֮ĸ
		// 3. y=xtηٽyתΪֵ
		double t = 0.0;
		double y = 0.0;
		double x = 0.0;

		t = Math.pow(4, -1 * iEXP[ConstantData.CHANNEL_DIR]);

		x = Math.abs((double) (rotateDegree / maxRotateDegree));
		if (x > 1)
			x = 1.0;
		y = Math.pow(x, t);

		// ֵҪͨתãbChnRev[]һж
		if (!bChnRev[ConstantData.CHANNEL_DIR]) {
			if (0 > rotateDegree) {
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_DIR] - iDR[ConstantData.CHANNEL_DIR]
						* y);
			} else {
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_DIR] + iDR[ConstantData.CHANNEL_DIR]
						* y);
			}
		} else {
			if (0 < rotateDegree) {
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_DIR] - iDR[ConstantData.CHANNEL_DIR]
						* y);
			} else {
				pulseWidth = (int) (iMidPoint[ConstantData.CHANNEL_DIR] + iDR[ConstantData.CHANNEL_DIR]
						* y);
			}
		}

		if (iEPANegative[ConstantData.CHANNEL_DIR] > pulseWidth) {
			pulseWidth = iEPANegative[ConstantData.CHANNEL_DIR];
		} else if (iEPAPositive[ConstantData.CHANNEL_DIR] < pulseWidth) {
			pulseWidth = iEPAPositive[ConstantData.CHANNEL_DIR];
		}

		/**
		 * Աʱ
		 */
		/*
		 * ms = new Date().getTime()-d.getTime();
		 * Log.e("processDIR:",String.valueOf(ms)+"ms");
		 */

		return pulseWidth;
	}

	// ʱʹõĺڲ鿴пӦ̴
	private void drawRightZone() {
		paint.setColor(0x70ff0000);
		// ң
		canvas.drawCircle(directionCenter.x, directionCenter.y,
				directionRadius, paint);
		canvas.drawRect(directionCenter.x - directionRadius, directionCenter.y
				- directionRadius, directionCenter.x + directionRadius,
				directionCenter.y, paint);
	}

	/**
	 * һHandler࣬ڴյĶʱϢжǷҪݵwifiջ
	 */
	Handler handlerSendMsgTimer = new Handler() {
		public void handleMessage(Message msg) {
			// Ҫ
			switch (msg.what) {
			case MSG_SEND_BY_TIMER:
				if (null == socketServer) {
					// socketʱͣisMsgSendΪfalse
					isMsgSend = false;
				} else {
					synchronized (msgData) {
						if (isMsgSend) {
							isMsgSend = false;
						} else {
							// 0.2Ϣʱһݷ
							try {
								Log.d("handleMessage",
										"send message  handleMessage");
								sendMsg(socketServer, msgData, isSendABS);
								isMsgSend = false;
							} catch (Exception e) {
								Log.d("handleMessage",
										"send message in timer failed");
							}
						}
					}
				}
				break;
			}
			super.handleMessage(msg);

		}
	};

	public class threadSendMsgTimer implements Runnable {
		@Override
		public void run() {
			// TODO Auto-generated method stub
			while (isTimerEnable) {
				try {
					Thread.sleep(SEND_TIMER);// ߳ͣʱ൱ʱʱλms
					Message message = new Message();
					message.what = MSG_SEND_BY_TIMER;
					handlerSendMsgTimer.sendMessage(message);// ʱϢ
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

}

class BasicGLRenderer implements GLSurfaceView.Renderer {

	public BasicGLRenderer(Context context) {
		mContext = context;
		mTriangleVertices = ByteBuffer
				.allocateDirect(mTriangleVerticesData.length * FLOAT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asFloatBuffer();
		mTriangleVertices.put(mTriangleVerticesData).position(0);
	}

	public void onDrawFrame(GL10 glUnused) {
		Date d = null;
		long ms = 0;
		d = new Date();
		// Ignore the passed-in GL10 interface, and use the GLES20
		// class's static methods instead.
		GLES20.glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
		GLES20.glClear(GLES20.GL_DEPTH_BUFFER_BIT | GLES20.GL_COLOR_BUFFER_BIT);
		GLES20.glUseProgram(mProgram);
		checkGlError("glUseProgram");

		GLES20.glActiveTexture(GLES20.GL_TEXTURE0);
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, mTextureID);

		mTriangleVertices.position(TRIANGLE_VERTICES_DATA_POS_OFFSET);
		GLES20.glVertexAttribPointer(maPositionHandle, 3, GLES20.GL_FLOAT,
				false, TRIANGLE_VERTICES_DATA_STRIDE_BYTES, mTriangleVertices);
		checkGlError("glVertexAttribPointer maPosition");
		mTriangleVertices.position(TRIANGLE_VERTICES_DATA_UV_OFFSET);
		GLES20.glEnableVertexAttribArray(maPositionHandle);
		checkGlError("glEnableVertexAttribArray maPositionHandle");
		GLES20.glVertexAttribPointer(maTextureHandle, 2, GLES20.GL_FLOAT,
				false, TRIANGLE_VERTICES_DATA_STRIDE_BYTES, mTriangleVertices);
		checkGlError("glVertexAttribPointer maTextureHandle");
		GLES20.glEnableVertexAttribArray(maTextureHandle);
		checkGlError("glEnableVertexAttribArray maTextureHandle");

		long time = SystemClock.uptimeMillis() % 4000L;
		float angle = 0.090f * ((int) time);
		Matrix.setRotateM(mMMatrix, 0, angle, 0, 0, 1.0f);
		Matrix.multiplyMM(mMVPMatrix, 0, mVMatrix, 0, mMMatrix, 0);
		Matrix.multiplyMM(mMVPMatrix, 0, mProjMatrix, 0, mMVPMatrix, 0);

		GLES20.glUniformMatrix4fv(muMVPMatrixHandle, 1, false, mMVPMatrix, 0);
		GLES20.glDrawArrays(GLES20.GL_TRIANGLES, 0, 3);
		checkGlError("glDrawArrays");

		ms = new Date().getTime() - d.getTime();
		Log.e("refresh Drawing GL:", String.valueOf(ms) + "ms");
	}

	public void onSurfaceChanged(GL10 glUnused, int width, int height) {
		// Ignore the passed-in GL10 interface, and use the GLES20
		// class's static methods instead.
		GLES20.glViewport(0, 0, width, height);
		float ratio = (float) width / height;
		Matrix.frustumM(mProjMatrix, 0, -ratio, ratio, -1, 1, 3, 7);
	}

	public void onSurfaceCreated(GL10 glUnused, EGLConfig config) {

		// Ignore the passed-in GL10 interface, and use the GLES20
		// class's static methods instead.
		mProgram = createProgram(mVertexShader, mFragmentShader);
		if (mProgram == 0) {
			return;
		}
		maPositionHandle = GLES20.glGetAttribLocation(mProgram, "aPosition");
		checkGlError("glGetAttribLocation aPosition");
		if (maPositionHandle == -1) {
			throw new RuntimeException(
					"Could not get attrib location for aPosition");
		}
		maTextureHandle = GLES20.glGetAttribLocation(mProgram, "aTextureCoord");
		checkGlError("glGetAttribLocation aTextureCoord");
		if (maTextureHandle == -1) {
			throw new RuntimeException(
					"Could not get attrib location for aTextureCoord");
		}

		muMVPMatrixHandle = GLES20.glGetUniformLocation(mProgram, "uMVPMatrix");
		checkGlError("glGetUniformLocation uMVPMatrix");
		if (muMVPMatrixHandle == -1) {
			throw new RuntimeException(
					"Could not get attrib location for uMVPMatrix");
		}

		/*
		 * Create our texture. This has to be done each time the surface is
		 * created.
		 */

		int[] textures = new int[1];
		GLES20.glGenTextures(1, textures, 0);

		mTextureID = textures[0];
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, mTextureID);

		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MIN_FILTER, GLES20.GL_NEAREST);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MAG_FILTER, GLES20.GL_LINEAR);

		GLES20.glTexParameteri(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_S,
				GLES20.GL_REPEAT);
		GLES20.glTexParameteri(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_T,
				GLES20.GL_REPEAT);

		InputStream isBackground = mContext.getResources().openRawResource(
				R.drawable.background_2x);
		Bitmap bmpBackground;
		try {
			bmpBackground = BitmapFactory.decodeStream(isBackground);
		} finally {
			try {
				isBackground.close();
			} catch (IOException e) {
				// Ignore.
			}
		}

		GLUtils.texImage2D(GLES20.GL_TEXTURE_2D, 0, bmpBackground, 0);
		bmpBackground.recycle();

		Matrix.setLookAtM(mVMatrix, 0, 0, 0, -5, 0f, 0f, 0f, 0f, 1.0f, 0.0f);
	}

	private int loadShader(int shaderType, String source) {
		int shader = GLES20.glCreateShader(shaderType);
		if (shader != 0) {
			GLES20.glShaderSource(shader, source);
			GLES20.glCompileShader(shader);
			int[] compiled = new int[1];
			GLES20.glGetShaderiv(shader, GLES20.GL_COMPILE_STATUS, compiled, 0);
			if (compiled[0] == 0) {
				Log.e(TAG, "Could not compile shader " + shaderType + ":");
				Log.e(TAG, GLES20.glGetShaderInfoLog(shader));
				GLES20.glDeleteShader(shader);
				shader = 0;
			}
		}
		return shader;
	}

	private int createProgram(String vertexSource, String fragmentSource) {
		int vertexShader = loadShader(GLES20.GL_VERTEX_SHADER, vertexSource);
		if (vertexShader == 0) {
			return 0;
		}

		int pixelShader = loadShader(GLES20.GL_FRAGMENT_SHADER, fragmentSource);
		if (pixelShader == 0) {
			return 0;
		}

		int program = GLES20.glCreateProgram();
		if (program != 0) {
			GLES20.glAttachShader(program, vertexShader);
			checkGlError("glAttachShader");
			GLES20.glAttachShader(program, pixelShader);
			checkGlError("glAttachShader");
			GLES20.glLinkProgram(program);
			int[] linkStatus = new int[1];
			GLES20.glGetProgramiv(program, GLES20.GL_LINK_STATUS, linkStatus, 0);
			if (linkStatus[0] != GLES20.GL_TRUE) {
				Log.e(TAG, "Could not link program: ");
				Log.e(TAG, GLES20.glGetProgramInfoLog(program));
				GLES20.glDeleteProgram(program);
				program = 0;
			}
		}
		return program;
	}

	private void checkGlError(String op) {
		int error;
		while ((error = GLES20.glGetError()) != GLES20.GL_NO_ERROR) {
			Log.e(TAG, op + ": glError " + error);
			throw new RuntimeException(op + ": glError " + error);
		}
	}

	// ԭrendererı壺

	private static final int FLOAT_SIZE_BYTES = 4;
	private static final int TRIANGLE_VERTICES_DATA_STRIDE_BYTES = 5 * FLOAT_SIZE_BYTES;
	private static final int TRIANGLE_VERTICES_DATA_POS_OFFSET = 0;
	private static final int TRIANGLE_VERTICES_DATA_UV_OFFSET = 3;
	private final float[] mTriangleVerticesData = {
			// X, Y, Z, U, V
			-1.0f, -0.5f, 0, -0.5f, 0.0f, 1.0f, -0.5f, 0, 1.5f, -0.0f, 0.0f,
			1.11803399f, 0, 0.5f, 1.61803399f };

	private FloatBuffer mTriangleVertices;

	private final String mVertexShader = "uniform mat4 uMVPMatrix;\n"
			+ "attribute vec4 aPosition;\n" + "attribute vec2 aTextureCoord;\n"
			+ "varying vec2 vTextureCoord;\n" + "void main() {\n"
			+ "  gl_Position = uMVPMatrix * aPosition;\n"
			+ "  vTextureCoord = aTextureCoord;\n" + "}\n";

	private final String mFragmentShader = "precision mediump float;\n"
			+ "varying vec2 vTextureCoord;\n" + "uniform sampler2D sTexture;\n"
			+ "void main() {\n"
			+ "  gl_FragColor = texture2D(sTexture, vTextureCoord);\n" + "}\n";

	private float[] mMVPMatrix = new float[16];
	private float[] mProjMatrix = new float[16];
	private float[] mMMatrix = new float[16];
	private float[] mVMatrix = new float[16];

	private int mProgram;
	private int mTextureID;
	private int muMVPMatrixHandle;
	private int maPositionHandle;
	private int maTextureHandle;

	private Context mContext;
	private static String TAG = "BasicGLRenderer";

}